/*
Copyright (c) 2005-2006 r1ch.net

This software is provided 'as-is',  without any express or implied  warranty. In
no event will the authors be held liable for any damages arising from the use of
this software.

Permission is granted to anyone to use this software for any purpose,  including
commercial applications, and to alter it and redistribute it freely, subject  to
the following restrictions:

    1. The  origin of  this software  must not  be misrepresented;  you must not
    claim that you wrote  the original software. If  you use this software  in a
    product, an acknowledgment in the product documentation would be appreciated
    but is not required.

    2. Altered source versions must be  plainly marked as such, and must  not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source distribution.
*/

#define UNICODE 1

#include "../SDK/foobar2000.h"
#include "../helpers/helpers.h"
#include "winamp.h"

// {1D3BB858-26FA-4a70-ADB0-6EB567B32576}
static const GUID configGUID = 
{ 0x1d3bb858, 0x26fa, 0x4a70, { 0xad, 0xb0, 0x6e, 0xb5, 0x67, 0xb3, 0x25, 0x76 } };

//cfg_string cfg_format("cfg_format", "[%artist% - ]$if(%title%,[%album% - ]%title%,%_filename%)");
cfg_string cfg_format(configGUID, "[%artist% - ]$if(%title%,%title%,%_filename%)");

HWND hwndMain;

int fb2kKbps;
int fb2kTotalLength;
int fb2kKhz;
int fb2kCurPLEntry;
int fb2kNumChans;

int playingStatus = 0;

char fb2kFakeSongPath[MAX_PATH];

pfc::string8 fb2kSongTitle;
pfc::string8 fb2kFakeWindowTitle;
pfc::string8 trackNumber;

//metadb_handle *fb2kCurrentSongHandle = NULL;

void UpdateFakeWindowTitle (pfc::string8 trackTitle)
{
//	wchar_t	out[1024];

	fb2kFakeWindowTitle.set_string ("");
	fb2kFakeWindowTitle.add_string (trackNumber.get_ptr());
	fb2kFakeWindowTitle.add_string (". ");
	fb2kFakeWindowTitle.add_string (trackTitle.get_ptr());
	fb2kFakeWindowTitle.add_string (" - Winamp");

	//pfc::stringcvt::convert_utf8_to_wide (out, sizeof(out), fb2kFakeWindowTitle, fb2kFakeWindowTitle.get_length());

	uSetWindowText (hwndMain, fb2kFakeWindowTitle);
}

class foo_winamp_spam_callback : private play_callback
{
public:
	virtual void on_playback_starting(play_control::t_track_command p_command, bool p_paused)
	{
		playingStatus = 1;
	}

	virtual void on_playback_time(double p_time) {}
	virtual void on_playback_edited(metadb_handle_ptr p_track) {}
	virtual void on_playback_seek(double p_time) {}
	virtual void on_volume_change(float p_new_val) {}
	virtual void on_playback_pause(bool p_state)
	{
		if (p_state) 
			playingStatus = 3;
		else
			playingStatus = 1;
	}

	virtual void on_playback_stop(play_control::t_stop_reason reason)
	{
		playingStatus = 0;

		//if (fb2kCurrentSongHandle) {
			//fb2kCurrentSongHandle-> ();
			//fb2kCurrentSongHandle = NULL;
		//}
	}

	virtual void on_playback_dynamic_info_track(const file_info & p_info)
	{
		//fb2kSongTitle.set_string (p_info.meta_get ("Title", 0));
		//p_info.copy_meta
		static_api_ptr_t<play_control> pc;
		service_ptr_t<titleformat_object> script;
		if (static_api_ptr_t<titleformat_compiler>()->compile (script, cfg_format.get_ptr()))
		{
			metadb_handle_ptr meta;
			if (pc->get_now_playing (meta))
			{
				pc->playback_format_title_ex(meta, NULL, fb2kSongTitle, script, NULL, play_control::display_level_titles);
			}
			else
				fb2kSongTitle.set_string (p_info.meta_get ("Title", 0));
		}
		UpdateFakeWindowTitle (fb2kSongTitle);
	}

	virtual void on_playback_dynamic_info(const file_info & p_info)
	{
	}

	virtual void on_playback_new_track (metadb_handle_ptr metadb)
	{
		//pfc::string8 cmdKbps;
		//pfc::string8 cmdKhz;
		//pfc::string8 cmdTotal;
		//pfc::string8 cmdPath;
		//pfc::string8 cmdChans;

		//if (fb2kCurrentSongHandle) {
			//fb2kCurrentSongHandle->handle_release ();
			//fb2kCurrentSongHandle = NULL;
		//}

		//fb2kCurrentSongHandle = metadb.get_ptr ();

		static_api_ptr_t<play_control> pc;
		//metadb_handle_ptr handle;;
		//if (pc->get_now_playing(handle))
		{
			service_ptr_t<titleformat_object> script;
			if (static_api_ptr_t<titleformat_compiler>()->compile (script, cfg_format.get_ptr()))
			{
				pc->playback_format_title_ex(metadb, NULL, fb2kSongTitle, script, NULL, play_control::display_level_titles);
			}
		}

		t_size plIndex, trackIndex;
		if (static_api_ptr_t<playlist_manager>()->get_playing_item_location (&plIndex, &trackIndex))
		{
			char	buff[64];
			_snprintf (buff, sizeof(buff)-1, "%d", (int)trackIndex);
			trackNumber.set_string (buff);
		}
		else
			trackNumber.set_string ("0");

		const file_info * info;
		metadb->get_info_locked (info);

		//char	buff[64];
		//_snprintf (buff, sizeof(buff)-1, "%d", (int)info->get_length ());
		//cmdTotal.set_string (buff);

		//cmdKbps.set_string (info->info_get ("bitrate"));
		//cmdKhz.set_string (info->info_get ("samplerate"));
		//cmdPath.set_string (info->info_get ("bitrate"));
		//cmdPath.set_string (metadb->get_path());
		//cmdChans.set_string (info->info_get ("channels"));
		//cmdKbps.set_string (info->info_get ("bitrate"));

		fb2kTotalLength = (int)metadb->get_length ();
		fb2kKbps = (int)info->info_get_int ("bitrate");
		fb2kKhz = (int)info->info_get_int ("samplerate");
		fb2kNumChans = (int)info->info_get_int ("channels");

		/*metadb->get_length ();
		metadb->format_title(cmdTotal, "%_length_seconds%", NULL);
		metadb->format_title(cmdKbps, "%__bitrate%", NULL);
		metadb->format_title(cmdKhz, "%__samplerate%", NULL);
		metadb->format_title(cmdPath, "%_path%", NULL);
		metadb->format_title(cmdChans, "%__channels%", NULL);

		//metadb->handle_format_title(trackNumber, "%_playlist_number%", NULL);
		trackNumber.set_string ("");
		trackNumber.add_int (playlist_oper::get()->get_now_playing()+1);

		fb2kTotalLength = atoi (cmdTotal.get_ptr());// * 100;
		fb2kKbps = atoi (cmdKbps.get_ptr());
		fb2kKhz = atoi (cmdKhz.get_ptr());

		strncpy (fb2kFakeSongPath, cmdPath.get_ptr(), sizeof(fb2kFakeSongPath)-1);
		fb2kNumChans = atoi (cmdChans.get_ptr());

		fb2kCurrentSongHandle->handle_format_title(fb2kSongTitle, cfg_format.get_val(), NULL);
		fb2kSongTitle.get_ptr();*/

		strncpy (fb2kFakeSongPath, metadb->get_path(), sizeof(fb2kFakeSongPath)-1);

		UpdateFakeWindowTitle(fb2kSongTitle);
	}

	void doregister (void)
	{
		static_api_ptr_t<play_callback_manager> pcm;
		pcm->register_callback(this, flag_on_playback_new_track | flag_on_playback_dynamic_info_track | flag_on_playback_stop | flag_on_playback_starting, false);
	}

	void dounregister (void)
	{
		static_api_ptr_t<play_callback_manager> pcm;
		pcm->unregister_callback(this);
	}
};

static foo_winamp_spam_callback winampspam;

LRESULT CALLBACK WndProcMain(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_CLOSE:
			ShowWindow (hwnd, SW_HIDE);
			return TRUE;
		case WM_USER:
			switch (lParam)
			{
				case IPC_GETINFO:
					switch (wParam)
					{
						case 0:
							return fb2kKhz;
							break;
						case 1:
							return fb2kKbps;
							break;
						case 2:
							return fb2kNumChans;
							break;
					}
					break;

				case IPC_GETOUTPUTTIME:
					switch (wParam)
					{
						case 0:
							{
							//return (long)play_control::get()->playback_get_position() * 1000;
								static_api_ptr_t<play_control> pc;
								return (long)pc->playback_get_position () * 1000;
							}
							break;
						case 1:
							return fb2kTotalLength;
							break;
					}
					break;

				case IPC_GETPLAYLISTFILE:
					if (!strncmp (fb2kFakeSongPath, "file://", 7))
						return (long)(void *)(fb2kFakeSongPath + 7);
					else
						return (long)(void *)fb2kFakeSongPath;
					break;

				case IPC_ISPLAYING:
					return playingStatus;

				case IPC_GETPLAYLISTTITLE:
					return (long)(void *)fb2kSongTitle.get_ptr();
					break;

				case IPC_UPDTITLE:
					{
						//metadb_handle *current = play_control::get()->get_now_playing();
						//current->handle_update_info (NULL, true);
					}
					break;

				case IPC_GET_SHUFFLE:
					//return mainmenu_commands::
					//return menu_manager::is_command_checked ("Playback/Order/Random");
					return (static_api_ptr_t<playlist_manager>()->playback_order_get_active () >= 3 && static_api_ptr_t<playlist_manager>()->playback_order_get_active () <= 5) ? 1 : 0;
					break;

				case IPC_GET_REPEAT:
					return (static_api_ptr_t<playlist_manager>()->playback_order_get_active () >= 1 && static_api_ptr_t<playlist_manager>()->playback_order_get_active () <= 2) ? 1 : 0;
					//return menu_manager::is_command_checked ("Playback/Order/Repeat");
					break;

				case IPC_SET_SHUFFLE:
					if ((static_api_ptr_t<playlist_manager>()->playback_order_get_active () >= 3 && static_api_ptr_t<playlist_manager>()->playback_order_get_active () <= 5) ? 1 : 0 == (bool)lParam)
						break;
					else
						static_api_ptr_t<playlist_manager>()->playback_order_set_active (lParam ? 3 : 0);
					break;

				case IPC_SET_REPEAT:
					if ((static_api_ptr_t<playlist_manager>()->playback_order_get_active () >= 1 && static_api_ptr_t<playlist_manager>()->playback_order_get_active () <= 2) ? 1 : 0 == (bool)lParam)
						break;
					else
						static_api_ptr_t<playlist_manager>()->playback_order_set_active (lParam ? 2 : 0);
					break;

				case IPC_GETLISTPOS:
					return fb2kCurPLEntry;
					break;

				case IPC_IS_FOOBAR:
					return 1;

				case IPC_GETVERSION:
					return 0x2080;
					break;

				default:
					//pfc::string ("foo_winamp_spam: Unsupported WM_USER, lParam %d.\n", lParam);
					{
						char warning[128];
						sprintf (warning, "foo_winamp_spam: Unsupported WM_USER, lParam %d.\n", lParam);
						console::warning (warning);
					}
					break;
			}
	
			break;

		case WM_CREATE:
			return TRUE;
			break;

		case WM_COMMAND:
			switch(wParam)
			{
			case WINAMP_BUTTON2:
				//play_control::get()->play_start();
				standard_commands::main_play ();
				break;

			case WINAMP_BUTTON4:
				standard_commands::main_stop ();
				break;

			case WINAMP_BUTTON3:
				standard_commands::main_play_or_pause ();
				break;

			case WINAMP_BUTTON5:
				//play_control::get()->play_start (play_control::TRACK_COMMAND_NEXT);
				standard_commands::main_next ();
				break;

			case WINAMP_BUTTON1:
				//play_control::get()->play_start (play_control::TRACK_COMMAND_PREV);
				standard_commands::main_previous ();
				break;
			
			case WINAMP_VOLUMEUP:
				//play_control::get()->volume_up ();
				standard_commands::main_volume_up ();
				break;

			case WINAMP_VOLUMEDOWN:
				//play_control::get()->volume_down ();
				standard_commands::main_volume_down ();
				break;

			case WINAMP_FILE_PLAY:
				//menu_manager::run_command("Playlist/Add files...");
				standard_commands::main_add_files ();
				break;

			case WINAMP_OPTIONS_PREFS:
				//menu_manager::run_command("Foobar2000/Preferences");
				standard_commands::main_preferences ();
				break;

			case WINAMP_HELP_ABOUT:
				//menu_manager::run_command("Foobar2000/About");
				standard_commands::main_about ();
				break;

			case 40194:
				//menu_manager::run_command("Playlist/Search...");
				standard_commands::main_playlist_search ();
				break;

			case 40157:
				//play_control::get()->toggle_stop_after_current ();
				{
					static_api_ptr_t<play_control> pc;
					pc->toggle_stop_after_current ();
				}
				break;

			case 40001:
				//menu_manager::run_command("Foobar2000/Exit");
				standard_commands::main_exit ();
				break;

			default:
				{
					char warning[128];
					sprintf (warning, "foo_winamp_spam: Unsupported WM_COMMAND, wParam %d.\n", wParam);
					console::warning (warning);
				}
				break;

			/*case WM_COPYDATA:
				COPYDATASTRUCT cds;
				cds = *(COPYDATASTRUCT *)lParam;
				switch (cds.dwData) {
					case IPC_PLAYFILE:
						playable_location_i loc;
						char *buff = new char[*(int *)cds.cbData];
						strncpy (buff, (const char *)cds.lpData, *(int *)cds.cbData);
						loc.set_path (buff);
						delete buff;

						
						metadb * p_metadb = metadb::get();

						p_metadb->

						metadb_handle *temp = p_metadb->handle_create (&loc);
						play_control::get()->play_item (temp);
						temp->handle_release ();
				}*/
			}
			break;
	}

	return DefWindowProcA (hwnd, message, wParam, lParam);;
}

class foo_winamp_spam_initquit : public initquit
{
public:
	virtual void on_init()
	{
		WNDCLASSA wcex;

		wcex.style			= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc	= (WNDPROC)WndProcMain;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= core_api::get_my_instance();
		wcex.hIcon			= NULL; //LoadIcon(hInstance, (LPCTSTR)IDI_RCONOMATIC);
		wcex.hCursor		= LoadCursor (core_api::get_my_instance(), MAKEINTRESOURCE(32512));
		wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
		wcex.lpszMenuName	= NULL;
		wcex.lpszClassName	= "Winamp v1.x";

		RegisterClassA (&wcex);

		hwndMain = uCreateWindowEx (0, "Winamp v1.x", "Winamp v1.x", WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, 110, 110, 510, 110, NULL, NULL, core_api::get_my_instance(), NULL);

		winampspam.doregister ();
	}
	virtual void on_quit() {
	
		if (hwndMain)
			DestroyWindow (hwndMain);

		hwndMain = NULL;

		UnregisterClass (L"Winamp v1.x", core_api::get_my_instance());

		winampspam.dounregister ();
	}
};


//static service_factory_single_t<foo_winamp_spam_callback> foo;
//static service_factory_single_t<foo_winamp_spam_initquit> bar;

static initquit_factory_t< foo_winamp_spam_initquit > foo_initquit;
//static play_callback_manager <foo_winamp_spam_callback> foo_callback;

DECLARE_COMPONENT_VERSION ("Winamp API Emulator", "0.90", "foo_winamp_spam by R1CH\n\nwww.r1ch.net");
